from django import template

register = template.Library()

from django.db.models import Q
from django.contrib.auth.models import User
from wagtail.models import Page
from math import ceil
import calendar
from ecom.models import Category,CategoryPage,ProductPage,ProdNotification,ProductAttributeValue,ProductVariantAttributeValue

from PIL import Image

@register.filter()
def img_ori(image):
    # img = Image.open(image)
    img = image
    # Get dimensions
    width = img.width
    height = img.height
    
    # Calculate aspect ratio
    def calculate_ratio(w, h):
        def gcd(a, b):
            return a if b == 0 else gcd(b, a % b)
        r = gcd(w, h)
        return f"{w//r}:{h//r}"
    
    aspect_ratio = calculate_ratio(width, height)
    
    # Determine orientation
    if width > height:
        orientation = 'landscape'
    elif height > width:
        orientation = 'portrait'
    else:
        orientation = 'square'
    
    return orientation


@register.filter(name='split')
def split(value, key):
    return value.split(key)[-1]

# @register.simple_tag
# def total_product_list(slug):
#     print("Slug=",slug)
#     return ProductPage.objects.filter(cat__slug=slug)

@register.simple_tag
def prod_av_compare(prod,attr):
    return ProductAttributeValue.objects.filter(product=prod,attribute__attr__name=attr).order_by("-id").first()

@register.simple_tag
def prod_var_av_compare(prod,attr):
    return ProductVariantAttributeValue.objects.filter(product=prod,attribute__attr__name=attr).order_by("-id").first()

from datetime import date,datetime
from pytz import timezone

@register.simple_tag
def notify(user):
    return ProdNotification.objects.filter(user=user,product__launchDate__gte=datetime.now().astimezone(timezone('UTC'))).count()


@register.simple_tag
def categories():
    return Category.objects.all()

# @register.simple_tag
# def find_category(name):
#     try:
#         return Category.objects.get(name=name)
#     except:
#         return None
    
    
@register.simple_tag
def cat_mob_menu():
    return CategoryPage.objects.filter(show_in_mobile=True)

# @register.simple_tag
# def cat_full_menu():
#     return CategoryPage.objects.filter(show_in_menus=True)

@register.simple_tag
def category_list():
    return CategoryPage.objects.all()

# @register.simple_tag
# def find_product_list(slug):
#     return ProductPage.objects.all()

